Magellan Linux

Diff of /trunk/installer-simple/bin/installer.sh.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 2335 by niro, Fri Jan 3 14:07:34 2014 UTC revision 2425 by niro, Tue Jan 7 13:57:40 2014 UTC
# Line 7  Line 7 
7  # Niels Rogalla <niro@magellan-linux.de>  # Niels Rogalla <niro@magellan-linux.de>
8  #  #
9    
10    # ignore the environment
11    LC_ALL=C
12    # include dir
13  INSTALLER_LIBDIR="%LIBDIR%"  INSTALLER_LIBDIR="%LIBDIR%"
14    
15  # configuration  # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
16  if [ -e %SYSCONFDIR%/installer.conf ]  # -> now in images.conf
17  then  CURRENTLINE=0
18   source %SYSCONFDIR%/installer.conf  
19  else  die()
20   die "/etc/installer.conf not found"  {
21  fi   echo "Error: $@"
22     exit 1
23    }
24    
25  #images: (get ${CDIMAGENAME})  # load common includes
26    for inc in %SYSCONFDIR%/installer.conf \
27     ${INSTALLER_LIBDIR}/functions/common.sh \
28     ${INSTALLER_LIBDIR}/functions/common-dialogs.sh \
29     ${INSTALLER_LIBDIR}/functions/hwdetection.sh \
30     ${INSTALLER_LIBDIR}/functions/installer-dialogs.sh
31    do
32     if [ -e ${inc} ]
33     then
34     source "${inc}"
35     else
36     die "'${inc}' not found"
37     fi
38    done
39    
40    # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
41    # -> now in images.conf
42    CDIMAGENAME=""
43    TOTALLINES=""
44    CURRENTLINE=0
45  if [ -e /mnt/cdrom/system/images.conf ]  if [ -e /mnt/cdrom/system/images.conf ]
46  then  then
47   source /mnt/cdrom/system/images.conf   source /mnt/cdrom/system/images.conf
48     # check if all required variables are set
49     [[ -z ${CDIMAGENAME} ]] && die "CDIMAGENAME is empty in /mnt/cdrom/system/images.conf"
50     [[ -z ${TOTALLINES} ]] && die "TOTALLINES is empty in /mnt/cdrom/system/images.conf"
51  else  else
52   die "/mnt/cdrom/system/images.conf not found"   die "/mnt/cdrom/system/images.conf not found"
53  fi  fi
54    
 # includes  
 source ${INSTALLER_LIBDIR}/functions/hwdetection.sh  
   
55  ### System/Config Version  ### System/Config Version
56  VERSION="%VERSIONTAG%"  VERSION="%VERSIONTAG%"
57  TITLE="${DEFAULT_TITLE} - ${VERSION}"  TITLE="${DEFAULT_TITLE} - ${VERSION}"
58    
59  CDPATH="${DEFAULT_CDPATH}"  # some sane defaults
60  INSTALLPATH="${DEFAULT_INSTALLPATH}"  CDROOT="${DEFAULT_CDROOT}"
61    INSTALLROOT="${DEFAULT_INSTALLROOT}"
62  ### WICHTIG: anzahl lines in der autosta_lx.tar.gz -1  KERNELPKG="${DEFAULT_KERNELPKG}"
63  CURRENTLINE=0  KERNELOPTS="${DEFAULT_KERNELOPTS}"
 #TOTALLINES=11072 # -> now in images.conf  
   
 # standard kernel opts  
 KERNELOPTS="quiet video=1024x768"  
   
 # grub options  
64  GRUBLEGACYOPTS=""  GRUBLEGACYOPTS=""
65  GRUB2OPTS=""  GRUB2OPTS=""
   
 # fdisk options  
66  FDISKPARTIONBELOW256MB=0  FDISKPARTIONBELOW256MB=0
   
 # default specialdevices  
67  SPECIALDEVICE=""  SPECIALDEVICE=""
68  FORMFACTOR="desktop"  FORMFACTOR="${DEFAULT_FORMFACTOR}"
   
 # target filesystem  
69  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"
70    
71  #################################################  #################################################
72  #  DIALOG BOXEN #  #  DIALOG BOXEN #
73  #################################################  #################################################
74    
75  die()  trap_exit()
76  {  {
77   ERROR=$1   is_mounted --location "${INSTALLROOT}/dev" && umount ${INSTALLROOT}/dev
78   RETVAL=$?   is_mounted --location "${INSTALLROOT}/proc" && umount ${INSTALLROOT}/proc
79     is_mounted --location "${INSTALLROOT}/sys" && umount ${INSTALLROOT}/sys
80     is_mounted --location "${INSTALLROOT}/boot" && umount ${INSTALLROOT}/boot
81     is_mounted --location "${INSTALLROOT}" && umount ${INSTALLROOT}
82    
83     echo $"Installation aborted."
84     exit 1
85    }
86    
87    dialog_die()
88    {
89     ERROR="$1"
90     RETVAL="$?"
91   dialog_install_failure   dialog_install_failure
92   exit 1   exit 1
93  }  }
94    
95  dialog_warning()  dialog_warning()
96  {  {
97   dialog \   local retval
98   --backtitle "${TITLE}" \  
99   --colors \   yesnobox $"\Z1 !!! Warning !!! \Zn\n\n\This harddrive will be irreversibly erased.\n\n\Do you want to continue ?"
100   --defaultno \   retval=$?
101   --yesno "\Z1 !!! Achtung !!! \Zn\n\n\   if [[ ${retval} -eq 1 ]]
  Diese Festplatte wird unwiederruflich geloescht werden.\n\n\  
  Soll ich wirklich fortfahren ?" 10 70  
  RES=$?  
  if [[ ${RES} -eq 1 ]]  
102   then   then
103   clear   clear
104   echo "Der Vorgang wurde abgebrochen."   echo $"The process was aborted."
105   exit 1   exit 1
106   fi   fi
107  }  }
108    
109  dialog_setup_hdd_info()  dialog_setup_hdd_info()
110  {  {
111   local SHDD="$(echo ${HDD} | sed 's/\/dev\///')"   local SHDD="${HDD//\/dev\/}"
112    
113   dialog \   messagebox -h $"[ Harddrive partitioning ]" \
114   --colors \   $"\nPlease create 1 partition.\n\n\[ \Z3${SHDD}1\Zn ] type: \Z3linux\Zn with the whole diskspace\n\Please mark ${SHDD}1 \Z3bootable\Zn."
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nBitte legen Sie 3 Partitionen an.\n\n\  
  [ \Z3${SHDD}1\Zn ] Typ: \Z3Linux\Zn mit ca. 50MB\n\  
  [ \Z3${SHDD}2\Zn ] Typ: \Z3Linux Swap\Zn mit ca. 256MB\n\  
  [ \Z3${SHDD}3\Zn ] Typ: \Z3Linux \Zn mit dem Rest (min. 256MB)\n\n\  
  Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81  
 }  
   
 dialog_setup_hdd_info_flash()  
 {  
  local SHDD="$(echo $HDD | sed 's/\/dev\///')"  
   
  dialog \  
  --colors \  
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nBitte legen Sie 1 Partition an.\n\n\  
  [ \Z3${SHDD}1\Zn ] Typ: \Z3Linux\Zn mit dem gesamten Speicher\n\  
  Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81  
115  }  }
116    
117  dialog_setup_hdd_info_auto()  dialog_setup_hdd_info_auto()
118  {  {
119   local SHDD="$(echo $HDD | sed 's/\/dev\///')"   local SHDD="${HDD//\/dev\/}"
120    
121   dialog \   messagebox -h $"[ Harddrive partitioning ]" \
122   --colors \   $"\Z1Warning!\Zn\n\nAll data on disk [ \Z3${HDD}\Zn ] will be erased!"
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nAchtung!\n\  
  Alle Daten werden von der Disk [ \Z3${HDD}\Zn ] gelöscht!" 12 81  
123  }  }
124    
125  dialog_setup_system_menu()  dialog_setup_system_menu()
126  {  {
127   local i   local mode
128     local retval
129    
130   i=$(dialog \   mode=$(menubox -h $"[ Harddrive partitioning ]" $"\nSelect an installation mode" \
131   --backtitle "${TITLE}" \   $"1:Automatic setup (recommended)" \
132   --title "[ Festplatten Partitionierung ]" \   ":" \
133   --cancel-label "Abbrechen" \   $":\Z1Expert modes:\Zn" \
134   --ok-label "Weiter" \   $"2:Common IDE-disk (manual setup)")
135   --stdout \   retval=$?
136   --colors \   [[ ${retval} -eq 1 ]] && return 1
137   --menu "\nWaehlen Sie die Installations-Methode" 14 70 5 \   if [[ ${retval} -eq 0 ]]
  "1" "Automatisches Setup (Empfohlen)" \  
  "" "" \  
  "" "\Z1Experten Modi:\Zn" \  
  "2" "Normale IDE-Disk (Manuell)" \  
  "3" "Flash-Speicher (Manuell)")  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
138   then   then
139   case "${i}" in   case "${mode}" in
140   "1") run_install_auto ;;   "1") run_install_auto ;;
141           "2") run_install_normal ;;   "2") run_install_normal ;;
  "3") run_install_flash ;;  
142   "") dialog_setup_system_menu;;   "") dialog_setup_system_menu;;
143   esac   esac
144   fi   fi
# Line 161  dialog_setup_system_menu() Line 146  dialog_setup_system_menu()
146    
147  dialog_hardware_detection()  dialog_hardware_detection()
148  {  {
149   local i   local message
  local hwtmp  
   
  if [ -x $(which mktemp &> /dev/null) ]  
  then  
  hwtmp="$(mktemp)"  
  else  
  hwtmp="/tmp/hwtmp.sh"  
  fi  
150    
151   [[ ! -z ${installdevs} ]] && installdevs=""   run_hardware_detection_disks
152    
153   echo "dialog \\"  > ${hwtmp}   message+=$"Harddrives:\n"
  echo "--backtitle \"${TITLE}\" \\" >> ${hwtmp}  
  echo "--ok-label \"Weiter\" \\" >> ${hwtmp}  
  echo "--stdout \\" >> ${hwtmp}  
  echo "--colors \\" >> ${hwtmp}  
  echo "--msgbox \"Gefundene Hardware:\n\n \\" >> ${hwtmp}  
  echo " Festplatten:\n \\" >> ${hwtmp}  
154    
155   if [[ ! -z ${scsidisks} ]]   if [[ ! -z ${ALL_DISKS} ]]
156   then   then
157   for i in ${scsidisks}   for i in ${ALL_DISKS}
158   do   do
159   if [[ ${i} != ${cdromdev} ]]   message+="\Z3${i}\Zn "
  then  
  echo " \\Z7SCSI: \\Z3${i}\\Zn\n \\" >> ${hwtmp}  
  installdevs="${installdevs} ${i}"  
  fi  
160   done   done
161     message+="\n"
162   fi   fi
163    
164   if [[ ! -z ${idedisks} ]]   if [[ ! -z ${ALL_CDROMS} ]]
165   then   then
166   for i in ${idedisks}   message+="\n"
167     message+=$"Optical disk drives:\n"
168     for i in ${ALL_CDROMS}
169   do   do
170   if [[ ${i} != ${cdromdev} ]]   message+="\Z3${i}\Zn"
  then  
  echo " \\Z7IDE:  \\Z3${i}\\Zn\n \\" >> ${hwtmp}  
  installdevs="${installdevs} ${i}"  
  fi  
171   done   done
172   fi   message+="\n"
   
  if [[ ! -z ${cdromdev} ]]  
  then  
  echo " \n \\" >> ${hwtmp}  
  echo " \\Z7andere Laufwerke:\n \\" >> ${hwtmp}  
  echo " CDROM: \\Z3${cdromdev}\\Zn\n \\" >> ${hwtmp}  
173   fi   fi
174    
175   # other devices   # other devices
176   run_hardware_detection   run_hardware_detection
177   case "${SPECIALDEVICE}" in   case "${SPECIALDEVICE}" in
178   zotac*) echo " \n\n\n \\Z2Zotac Device erkannt.\\Zn \\" >> ${hwtmp} ;;   zotac*) message+=$"\n\Z2Zotac device detected.\Zn" ;;
179   rangee) echo " \n\n\n \\Z2Rangee Device erkannt.\\Zn \\" >> ${hwtmp} ;;   rangee) message+=$"\n\Z2Rangee device detected.\Zn" ;;
180   maxdata) echo " \n\n\n \\Z2Maxdata Device erkannt.\\Zn \\" >> ${hwtmp} ;;   maxdata) message+=$"\n\Z2Maxdata device detected.\Zn" ;;
181   *) echo " \n\n\n \\ZnStandard Device erkannt.\\Zn \\" >> ${hwtmp} ;;   *) message+=$"\n \\ZnCommon device detected.\Zn" ;;
182   esac   esac
183   if [[ ${FORMFACTOR} = laptop ]]   if [[ ${FORMFACTOR} = laptop ]]
184   then   then
185   echo " \n \\ZnFormfactor Laptop, Powersave Modus 'ondemand' wird aktiviert.\\Zn \\" >> ${hwtmp}   message+=$"\n\ZnFormfactor Laptop, activating 'ondemand' powersaving  mode.\Zn"
186   fi   fi
187    
188   echo " \" 14 70" >> ${hwtmp}   messagebox -y 15 -h $"Detected hardware:" "${message}"
  chmod a+x ${hwtmp}  
  ${hwtmp}  
   
  # remove tmp file  
  if [[ -f ${hwtmp} ]]  
  then  
  rm ${hwtmp}  
  fi  
189  }  }
190    
191  dialog_setup_hdd_partitions_manuell()  dialog_setup_hdd_partitions_manual()
192  {  {
193   local i   local i
194     local retval
195    
196   if [[ -z ${installdevs} ]]   if [[ -z ${ALL_DISKS} ]]
197   then   then
198   dialog \   dialog_no_harddrive_found
  --backtitle "${TITLE}" \  
  --ok-label "Beenden" \  
  --msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70  
199   exit 1   exit 1
200   else   else
201     HDD=$(dialog_select_target_harddrive)
202   echo "dialog \\" > /tmp/hddtmp.sh   retval=$?
203   echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh   [[ ${retval} -eq 1 ]] && return 1
204   echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh   if [[ ${retval} -eq 0 ]]
  echo "--cancel-label \"Beenden\" \\" >> /tmp/hddtmp.sh  
  echo "--stdout \\" >> /tmp/hddtmp.sh  
  echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh  
   
  for i in ${installdevs}  
  do  
  echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh  
  done  
  echo -e "\n" >> /tmp/hddtmp.sh  
   
  chmod a+x /tmp/hddtmp.sh  
  HDD="$(/tmp/hddtmp.sh)"  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
205   then   then
206   dialog_setup_hdd_info   dialog_setup_hdd_info
207   setup_hdd_partitions_manuell   setup_hdd_partitions_manual
208   fi   fi
209   fi   fi
210  }  }
211    
212  dialog_setup_hdd_partitions_manuell_flash()  dialog_setup_hdd_partitions_auto()
213  {  {
214   local i   local i
215     local retval
216    
217   if [[ -z ${installdevs} ]]   if [[ -z ${ALL_DISKS} ]]
218   then   then
219   dialog \   dialog_no_harddrive_found
  --backtitle "${TITLE}" \  
  --ok-label "Beenden" \  
  --msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70  
220   exit 1   exit 1
221   else   else
222     HDD=$(dialog_select_target_harddrive)
223   echo "dialog \\" > /tmp/hddtmp.sh   retval=$?
224   echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh   [[ ${retval} -eq 1 ]] && return 1
225   echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh   if [[ ${retval} -eq 0 ]]
  echo "--cancel-label \"Beenden\" \\" >> /tmp/hddtmp.sh  
  echo "--stdout \\" >> /tmp/hddtmp.sh  
  echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh  
   
  for i in ${installdevs}  
  do  
  echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh  
  done  
  echo -e "\n" >> /tmp/hddtmp.sh  
   
  chmod a+x /tmp/hddtmp.sh  
  HDD="$(/tmp/hddtmp.sh)"  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
226   then   then
227   dialog_setup_hdd_info_flash   dialog_setup_hdd_info_auto
228   setup_hdd_partitions_manuell_flash   dialog_setup_hdd_create_partitions
229     setup_hdd_partitions_auto
230   fi   fi
231   fi   fi
232  }  }
233    
234  dialog_setup_hdd_partitions_auto()  run_hardware_detection_disks()
235  {  {
236   local i   local bootdev
237    
238   if [[ -z ${installdevs} ]]   # all disks but exclude ramdisks
239     export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')
240     # remove the boot device from ALL_DISKS if it was an usbstick
241     if [[ $(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]
242   then   then
243   dialog \   bootdev="$(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')"
244   --backtitle "${TITLE}" \   export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")
  --ok-label "Beenden" \  
  --msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70  
  exit 1  
  else  
   
  echo "dialog \\" > /tmp/hddtmp.sh  
  echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh  
  echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh  
  echo "--cancel-label \"Beenden\" \\" >> /tmp/hddtmp.sh  
  echo "--stdout \\" >> /tmp/hddtmp.sh  
  echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh  
   
  for i in ${installdevs}  
  do  
  echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh  
  done  
  echo -e "\n" >> /tmp/hddtmp.sh  
   
  chmod a+x /tmp/hddtmp.sh  
  HDD="$(/tmp/hddtmp.sh)"  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
  then  
  dialog_setup_hdd_info_auto  
  dialog_setup_hdd_create_partitions  
  setup_hdd_partitions_auto  
  fi  
245   fi   fi
246     export ALL_CDROMS="$(get_hwinfo cdrom)"
247  }  }
248    
249  dialog_setup_hdd_create_partitions()  dialog_setup_hdd_create_partitions()
# Line 379  dialog_install_system_image() Line 274  dialog_install_system_image()
274   --gauge "Kopiere System-Image ..." 6 80   --gauge "Kopiere System-Image ..." 6 80
275  }  }
276    
277  dialog_install_meter()  install_meter()
278  {  {
279   while [[ ${CURRENTLINE} != ${TOTALLINES} ]]   while [[ ${CURRENTLINE} != ${TOTALLINES} ]]
280   do   do
# Line 420  dialog_install_failure() Line 315  dialog_install_failure()
315    
316  dialog_main()  dialog_main()
317  {  {
318   METHOD=0   local method=0
319     local retval
320    
321   while [[ ${METHOD} -le 2 ]]   while [[ ${method} -le 2 ]]
322   do   do
323   METHOD=$(dialog \   method=$(menubox $"Configuration:" \
324   --backtitle "${TITLE}" \   $"1:Install system" \
325   --no-cancel \   $"2:Show detected harddrives" \
326   --ok-label "Weiter" \   $"3:Exit and reboot" \
327   --stdout \   $"4:Exit and drop into a shell")
328   --menu "Konfiguration" 14 70 5 \   retval=$?
329   "1" "AutoSta_LX installieren" \   [[ ${retval} -eq 1 ]] && exit 1
330   "2" "Uebersicht gefundener Laufwerke" \   if [[ ${retval} -eq 0 ]]
  "3" "Beenden und neustarten" \  
  "4" "Beenden und eine Shell starten")  
  RES=$?  
  [[ ${RES} -eq 1 ]] && exit 1  
  if [[ ${RES} -eq 0 ]]  
331   then   then
332   case ${METHOD} in   case ${method} in
333           "1") dialog_setup_system_menu ;;   "1") dialog_setup_system_menu ;;
334   "2") dialog_hardware_detection ;;   "2") dialog_hardware_detection ;;
335   "3") install_do_reboot ;;   "3") install_do_reboot ;;
336   "4") /bin/bash --login -i ;;   "4") /bin/bash --login -i ;;
# Line 513  hdd_size_below_256mb() Line 404  hdd_size_below_256mb()
404   local hdd="$1"   local hdd="$1"
405   local size   local size
406   local retval   local retval
407   [[ -z ${hdd} ]] && die "Error: get_hdd_size() no \$hdd given!"   [[ -z ${hdd} ]] && dialog_die "Error: get_hdd_size() no \$hdd given!"
408    
409   size=$(fdisk -l ${hdd} | grep "Disk.*${hdd}" | sed 's:.*,\ \(.*\)\ byte.*:\1:')   size=$(fdisk -l ${hdd} | grep "Disk.*${hdd}" | sed 's:.*,\ \(.*\)\ byte.*:\1:')
410   if [[ ${size} -le 257000000 ]]   if [[ ${size} -le 257000000 ]]
# Line 542  setup_hdd_partitions_auto() Line 433  setup_hdd_partitions_auto()
433   fi   fi
434    
435   ## delete disk   ## delete disk
436   dd if=/dev/zero of=${HDD} count=1 &> /dev/null || die   dd if=/dev/zero of=${HDD} count=1 &> /dev/null || dialog_die
437    
438   if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]   if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]
439   then   then
# Line 588  EOF Line 479  EOF
479   fi   fi
480  }  }
481    
482  setup_hdd_partitions_manuell()  setup_hdd_partitions_manual()
 {  
  BOOTHDD="${HDD}1"  
  SWAPHDD="${HDD}2"  
  ROOTHDD="${HDD}3"  
   
  ## hdds partitionieren manuell  
  cfdisk ${HDD} || die  
 }  
   
 setup_hdd_partitions_manuell_flash()  
483  {  {
484   ROOTHDD="${HDD}1"   ROOTHDD="${HDD}1"
485    
486   ## hdds partitionieren manuell   ## hdds partitionieren manual
487   cfdisk ${HDD} || die   cfdisk ${HDD} || dialog_die
488  }  }
489    
490  setup_hdd_format()  setup_hdd_format()
491  {  {
492   mkswap ${SWAPHDD} || die   mke2fs -j -q ${ROOTHDD} || dialog_die
  mke2fs -j -q ${BOOTHDD} || die  
  mke2fs -j -q ${ROOTHDD} || die  
 }  
   
 setup_hdd_format_flash()  
 {  
  mke2fs -j -q ${ROOTHDD} || die  
493  }  }
494    
495  install_mount_rootfs()  install_mount_rootfs()
496  {  {
497   swapon ${SWAPHDD} || die   mount ${ROOTHDD} ${INSTALLROOT} || dialog_die
498   mount ${ROOTHDD} ${INSTALLPATH} || die   install -d ${INSTALLROOT}/boot || dialog_die
499   install -d ${INSTALLPATH}/boot || die   cd ${INSTALLROOT} || dialog_die
  mount ${BOOTHDD} ${INSTALLPATH}/boot || die  
  cd ${INSTALLPATH} || die  
 }  
   
 install_mount_rootfs_flash()  
 {  
  mount ${ROOTHDD} ${INSTALLPATH} || die  
  install -d ${INSTALLPATH}/boot || die  
  cd ${INSTALLPATH} || die  
500  }  }
501    
502  install_system_image()  install_system_image()
503  {  {
504   tar xvjpf ${CDPATH}/system/${CDIMAGENAME} -C ${INSTALLPATH}   tar xvjpf ${CDROOT}/system/${CDIMAGENAME} -C ${INSTALLROOT}
505  }  }
506    
507  install_bootsector_chroot()  install_bootsector_chroot()
508  {  {
509   local my_roothdd   local my_roothdd
510   local grubconf=${INSTALLPATH}/boot/grub/grub.conf   local grubconf=${INSTALLROOT}/boot/grub/grub.conf
511   local grub2conf=/boot/grub/grub.cfg   local grub2conf=/boot/grub/grub.cfg
512    
513   # check for grub2   # check for grub2
514   if [[ -f ${INSTALLPATH}/sbin/grub-mkconfig ]]   if [[ -f ${INSTALLROOT}/sbin/grub-mkconfig ]]
515   then   then
516   # needed by grub-mkconfig on the first run   # needed by grub-mkconfig on the first run
517   if [[ ! -f ${INSTALLPATH}/boot/grub/video.lst ]]   if [[ ! -f ${INSTALLROOT}/boot/grub/video.lst ]]
518   then   then
519   install -m0644 ${INSTALLPATH}/lib/grub/*/video.lst ${INSTALLPATH}/boot/grub/video.lst || die   install -m0644 ${INSTALLROOT}/lib/grub/*/video.lst ${INSTALLROOT}/boot/grub/video.lst || dialog_die
520   fi   fi
521    
522   # set kernelopts   # set kernelopts
523   if [[ -f ${INSTALLPATH}/etc/conf.d/grub ]]   if [[ -f ${INSTALLROOT}/etc/conf.d/grub ]]
524   then   then
525   sed -i "s:^\(export GRUB_CMDLINE_LINUX_DEFAULT=\).*:\1\"${KERNELOPTS}\":" ${INSTALLPATH}/etc/conf.d/grub || die   sed -i "s:^\(export GRUB_CMDLINE_LINUX_DEFAULT=\).*:\1\"${KERNELOPTS}\":" ${INSTALLROOT}/etc/conf.d/grub || dialog_die
526   else   else
527   echo "export GRUB_CMDLINE_LINUX_DEFAULT=\"${KERNELOPTS}\"" >  ${INSTALLPATH}/etc/conf.d/grub || die   echo "export GRUB_CMDLINE_LINUX_DEFAULT=\"${KERNELOPTS}\"" >  ${INSTALLROOT}/etc/conf.d/grub || dialog_die
528   fi   fi
529   echo 'grub-mkdevicemap' > ${INSTALLPATH}/root/.installrc || die   echo 'grub-mkdevicemap' > ${INSTALLROOT}/root/.installrc || dialog_die
530   echo "LC_ALL=C grub-mkconfig -o ${grub2conf}  &> /dev/null" >> ${INSTALLPATH}/root/.installrc || die   echo "LC_ALL=C grub-mkconfig -o ${grub2conf}  &> /dev/null" >> ${INSTALLROOT}/root/.installrc || dialog_die
531   echo "grub-install --no-floppy ${HDD} &> /dev/null" >> ${INSTALLPATH}/root/.installrc || die   echo "grub-install --no-floppy ${HDD} &> /dev/null" >> ${INSTALLROOT}/root/.installrc || dialog_die
532   echo "exit 0" >> ${INSTALLPATH}/root/.installrc || die   echo "exit 0" >> ${INSTALLROOT}/root/.installrc || dialog_die
533    
534   # grub-legacy   # grub-legacy
535   else   else
536   ### grubconf schreiben   ### grubconf schreiben
537   source ${INSTALLPATH}/boot/kernelversion   source ${INSTALLROOT}/boot/kernelversion
538    
539   #for alx only   #for alx only
540   if [ -e ${INSTALLPATH}/etc/alx_version ]   if [ -e ${INSTALLROOT}/etc/alx_version ]
541   then   then
542   OLD_ALXVER="${ALXVER}"   OLD_ALXVER="${ALXVER}"
543   source ${INSTALLPATH}/etc/alx_version   source ${INSTALLROOT}/etc/alx_version
544   KRNVER="ALX-${ALXVER}"   KRNVER="ALX-${ALXVER}"
545   ALXVER="${OLD_ALXVER}"   ALXVER="${OLD_ALXVER}"
546   fi   fi
# Line 692  install_bootsector_chroot() Line 557  install_bootsector_chroot()
557   my_roothdd="${ROOTHDD}"   my_roothdd="${ROOTHDD}"
558   fi   fi
559    
560   : > ${grubconf} || die   : > ${grubconf} || dialog_die
561   echo "default 0" >> ${grubconf} || die   echo "default 0" >> ${grubconf} || dialog_die
562   echo "timeout 3" >> ${grubconf} || die   echo "timeout 3" >> ${grubconf} || dialog_die
563   # using current root password   # using current root password
564   echo "password --md5 $(cat ${INSTALLPATH}/etc/shadow | grep root | cut -d: -f2)"  >> ${grubconf} || die   echo "password --md5 $(cat ${INSTALLROOT}/etc/shadow | grep root | cut -d: -f2)"  >> ${grubconf} || dialog_die
565    
566   echo  >> ${grubconf} || die   echo  >> ${grubconf} || dialog_die
567   echo "# normal boot" >> ${grubconf} || die   echo "# normal boot" >> ${grubconf} || dialog_die
568   echo "title ${KRNVER}" >> ${grubconf} || die   echo "title ${KRNVER}" >> ${grubconf} || dialog_die
569   echo "root (hd0,0)" >> ${grubconf} || die   echo "root (hd0,0)" >> ${grubconf} || dialog_die
570   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS}" >> ${grubconf} || die   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS}" >> ${grubconf} || dialog_die
571   if is_initrd_supported   if is_initrd_supported
572   then   then
573   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || die   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die
574   fi   fi
575    
576   echo >> ${grubconf} || die   echo >> ${grubconf} || dialog_die
577   echo "# admin boot" >> ${grubconf} || die   echo "# admin boot" >> ${grubconf} || dialog_die
578   echo "title ${KRNVER} - Re-run hardware-detection" >> ${grubconf} || die   echo "title ${KRNVER} - Re-run hardware-detection" >> ${grubconf} || dialog_die
579   echo "lock"  >> ${grubconf} || die   echo "lock"  >> ${grubconf} || dialog_die
580   echo "root (hd0,0)" >> ${grubconf} || die   echo "root (hd0,0)" >> ${grubconf} || dialog_die
581   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} hardware-auto-detection" >> ${grubconf} || die   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} hardware-auto-detection" >> ${grubconf} || dialog_die
582   if is_initrd_supported   if is_initrd_supported
583   then   then
584   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || die   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die
585   fi   fi
586    
587   echo >> ${grubconf} || die   echo >> ${grubconf} || dialog_die
588   echo "title ${KRNVER} - Reset *all* local settings" >> ${grubconf} || die   echo "title ${KRNVER} - Reset *all* local settings" >> ${grubconf} || dialog_die
589   echo "lock"  >> ${grubconf} || die   echo "lock"  >> ${grubconf} || dialog_die
590   echo "root (hd0,0)" >> ${grubconf} || die   echo "root (hd0,0)" >> ${grubconf} || dialog_die
591   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} alx-reset-settings" >> ${grubconf} || die   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} alx-reset-settings" >> ${grubconf} || dialog_die
592   if is_initrd_supported   if is_initrd_supported
593   then   then
594   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || die   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die
595   fi   fi
596    
597   # bootsector schreiben chrooted schreiben (lfs/magellan)   # bootsector schreiben chrooted schreiben (lfs/magellan)
598   cat > ${INSTALLPATH}/root/.installrc << CHROOTEOF   cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF
599  /usr/sbin/grub --no-floppy --batch << "EOF" 1> /dev/null 2> /dev/null  /usr/sbin/grub --no-floppy --batch << "EOF" 1> /dev/null 2> /dev/null
600  root (hd0,0)  root (hd0,0)
601  setup (hd0)  setup (hd0)
# Line 740  exit 0 Line 605  exit 0
605  CHROOTEOF  CHROOTEOF
606   fi   fi
607    
608   ## enters chroot   ## enter chroot
609   mount -t proc proc ${INSTALLPATH}/proc   mount -t proc proc ${INSTALLROOT}/proc
610   mount -t sysfs sysfs ${INSTALLPATH}/sys   mount -t sysfs sysfs ${INSTALLROOT}/sys
611   mount -o bind /dev ${INSTALLPATH}/dev   mount -o bind /dev ${INSTALLROOT}/dev
612   chroot ${INSTALLPATH} /bin/bash --rcfile /root/.installrc -i   chroot ${INSTALLROOT} /bin/bash --rcfile /root/.installrc -i
613   umount ${INSTALLPATH}/proc   umount ${INSTALLROOT}/proc
614   umount ${INSTALLPATH}/sys   umount ${INSTALLROOT}/sys
615   umount ${INSTALLPATH}/dev   umount ${INSTALLROOT}/dev
616   rm ${INSTALLPATH}/root/.installrc   rm ${INSTALLROOT}/root/.installrc
617  }  }
618    
619  is_initrd_supported()  is_initrd_supported()
620  {  {
621   # only generate initrds if the cmd exists   # only generate initrds if the cmd exists
622   [[ -x ${INSTALLPATH}/sbin/mkinitrd ]] && return 0   [[ -x ${INSTALLROOT}/sbin/mkinitrd ]] && return 0
623   return 1   return 1
624  }  }
625    
# Line 785  install_initrd_chroot() Line 650  install_initrd_chroot()
650   fi   fi
651    
652   # install an appropriate uvesafb.conf   # install an appropriate uvesafb.conf
653   install -d ${INSTALLPATH}/etc/modprobe.d || die   install -d ${INSTALLROOT}/etc/modprobe.d || dialog_die
654   echo "options uvesafb mode_option=1024x768-32@60 scroll=ywrap" > ${INSTALLPATH}/etc/modprobe.d/uvesafb.conf || die   echo "options uvesafb mode_option=1024x768-32@60 scroll=ywrap" > ${INSTALLROOT}/etc/modprobe.d/uvesafb.conf || dialog_die
655    
656   # install an appropriate viafb.conf   # install an appropriate viafb.conf
657   echo "options viafb viafb_mode=1024x768 viafb_refresh=60" > ${INSTALLPATH}/etc/modprobe.d/viafb.conf || die   echo "options viafb viafb_mode=1024x768 viafb_refresh=60" > ${INSTALLROOT}/etc/modprobe.d/viafb.conf || dialog_die
658    
659   # install an appropriate i810fb.conf   # install an appropriate i810fb.conf
660   echo "options i810fb xres=1024 yres=768 bpp=16 mtrr=1 hsync1=30 hsync2=62 vsync1=30 vsync2=60"  > ${INSTALLPATH}/etc/modprobe.d/i810fb.conf || die   echo "options i810fb xres=1024 yres=768 bpp=16 mtrr=1 hsync1=30 hsync2=62 vsync1=30 vsync2=60"  > ${INSTALLROOT}/etc/modprobe.d/i810fb.conf || dialog_die
661    
662   cat > ${INSTALLPATH}/root/.installrc << CHROOTEOF   cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF
663  echo "MODULES=\"${FORMAT_FILESYSTEM} ${DISKMODS} ${OLDATAMODS} ${PATAMODS} ${SATAMODS} ${DRMMODS} ${FBMODS} ${OTHERMODS}\"" > /etc/conf.d/mkinitrd  echo "MODULES=\"${FORMAT_FILESYSTEM} ${DISKMODS} ${OLDATAMODS} ${PATAMODS} ${SATAMODS} ${DRMMODS} ${FBMODS} ${OTHERMODS}\"" > /etc/conf.d/mkinitrd
664  mkinitrd -f /boot/$(readlink /boot/initrd) $(readlink /boot/vmlinuz | sed "s:kernel-::g") > /dev/null  mkinitrd -f /boot/$(readlink /boot/initrd) $(readlink /boot/vmlinuz | sed "s:kernel-::g") > /dev/null
665  exit 0  exit 0
666  CHROOTEOF  CHROOTEOF
667    
668   ## enters chroot   ## enters chroot
669   mount -t proc proc ${INSTALLPATH}/proc   mount -t proc proc ${INSTALLROOT}/proc
670   mount -t sysfs sysfs ${INSTALLPATH}/sys   mount -t sysfs sysfs ${INSTALLROOT}/sys
671   mount -o bind /dev ${INSTALLPATH}/dev   mount -o bind /dev ${INSTALLROOT}/dev
672   chroot ${INSTALLPATH} /bin/bash --rcfile /root/.installrc -i   chroot ${INSTALLROOT} /bin/bash --rcfile /root/.installrc -i
673   umount ${INSTALLPATH}/proc   umount ${INSTALLROOT}/proc
674   umount ${INSTALLPATH}/sys   umount ${INSTALLROOT}/sys
675   umount ${INSTALLPATH}/dev   umount ${INSTALLROOT}/dev
676   rm ${INSTALLPATH}/root/.installrc   rm ${INSTALLROOT}/root/.installrc
677  }  }
678    
679  is_uuid_supported()  is_uuid_supported()
680  {  {
681   if [[ -x $(which busybox.mkinitrd &> /dev/null) ]]   if [[ -x $(type -P busybox.mkinitrd) ]]
682   then   then
683   # only detect uuids if supported   # only detect uuids if supported
684   if [[ ! -z $(busybox.mkinitrd | grep blkid) ]]   if [[ ! -z $(busybox.mkinitrd | grep blkid) ]]
# Line 832  get_uuid() Line 697  get_uuid()
697   local TYPE   local TYPE
698    
699   local dev="$1"   local dev="$1"
700   [[ -z ${dev} ]] && die "no dev given"   [[ -z ${dev} ]] && dialog_die "no dev given"
701    
702   # check if given device is already an UUID   # check if given device is already an UUID
703   if [[ ${dev/UUID=/}x != ${dev}x ]]   if [[ ${dev/UUID=/}x != ${dev}x ]]
# Line 849  install_system_settings() Line 714  install_system_settings()
714   # schreibe fstab   # schreibe fstab
715   if is_uuid_supported   if is_uuid_supported
716   then   then
717   echo -e "UUID=$(get_uuid ${BOOTHDD})\t/boot\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1" > ${INSTALLPATH}/etc/fstab || die   echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
  echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
718   else   else
719   echo -e "${BOOTHDD}\t/boot\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1" > ${INSTALLPATH}/etc/fstab || die   echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
  echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
720   fi   fi
721   # not needed busybox loads all with swapon -a, even if not mentioned in fstab   # not needed busybox loads all with swapon -a, even if not mentioned in fstab
722   #echo -e "UUID='$(get_uuid ${SWAPHDD})'\tswap\tswap\tpri=1\t0 0" >> ${INSTALLPATH}/etc/fstab || die   #echo -e "UUID='$(get_uuid ${SWAPHDD})'\tswap\tswap\tpri=1\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
723   echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die   echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
724   echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die   echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
725    
726   # install network config skeleton   # install network config skeleton
727   install -m0644 ${INSTALLPATH}/etc/alxconfig-ng/skel/net/net.eth0 ${INSTALLPATH}/etc/conf.d/ || die   install -m0644 ${INSTALLROOT}/etc/alxconfig-ng/skel/net/net.eth0 ${INSTALLROOT}/etc/conf.d/ || dialog_die
728    
729   # intel framebufer quirk   # intel framebufer quirk
730   if [[ -e /proc/fb ]]   if [[ -e /proc/fb ]]
# Line 871  install_system_settings() Line 734  install_system_settings()
734   fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')   fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')
735   if [[ ${fbdev} != 0 ]]   if [[ ${fbdev} != 0 ]]
736   then   then
737   sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLPATH}/etc/splash/splash.conf || die   sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLROOT}/etc/splash/splash.conf || dialog_die
738   fi   fi
739   fi   fi
740   fi   fi
741  }  }
742    
 install_system_settings_flash()  
 {  
  # schreibe fstab  
  if is_uuid_supported  
  then  
  echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" > ${INSTALLPATH}/etc/fstab || die  
  else  
  echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" > ${INSTALLPATH}/etc/fstab || die  
  fi  
  echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
  echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
 }  
   
743  install_umount_rootfs()  install_umount_rootfs()
744  {  {
745   cd /   cd /
746   umount ${INSTALLPATH}/boot || die   umount ${INSTALLROOT}/boot || dialog_die
747   umount ${INSTALLPATH} || die   umount ${INSTALLROOT} || dialog_die
  swapoff ${SWAPHDD} || die  
 }  
   
 install_umount_rootfs_flash()  
 {  
  cd /  
  umount ${INSTALLPATH} || die  
748  }  }
749    
750  install_do_reboot()  install_do_reboot()
# Line 917  run_install_normal() Line 760  run_install_normal()
760  {  {
761   dialog_hardware_detection   dialog_hardware_detection
762    
763   dialog_setup_hdd_partitions_manuell   dialog_setup_hdd_partitions_manual
764   dialog_setup_hdd_format   dialog_setup_hdd_format
765   setup_hdd_format > /dev/null   setup_hdd_format > /dev/null
766   install_mount_rootfs   install_mount_rootfs
767   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image
768    
769   dialog_install_settings   dialog_install_settings
770   sleep 1   sleep 1
# Line 935  run_install_normal() Line 778  run_install_normal()
778   dialog_install_successful   dialog_install_successful
779  }  }
780    
 run_install_flash()  
 {  
  dialog_hardware_detection  
   
  dialog_setup_hdd_partitions_manuell_flash  
  dialog_setup_hdd_format  
  setup_hdd_format_flash > /dev/null  
  install_mount_rootfs_flash  
  (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image  
   
  dialog_install_settings  
  sleep 1  
  install_system_settings_flash  
  install_initrd_chroot  
   
  dialog_install_bootsector  
  install_bootsector_chroot  
   
  install_umount_rootfs_flash  
  dialog_install_successful  
 }  
   
781  run_install_auto()  run_install_auto()
782  {  {
783   dialog_hardware_detection   dialog_hardware_detection
784    
785   dialog_setup_hdd_partitions_auto   dialog_setup_hdd_partitions_auto
786   dialog_setup_hdd_format   dialog_setup_hdd_format
787   setup_hdd_format_flash > /dev/null   setup_hdd_format > /dev/null
788   install_mount_rootfs_flash   install_mount_rootfs
789   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image
790    
791   dialog_install_settings   dialog_install_settings
792   sleep 1   sleep 1
793   install_system_settings_flash   install_system_settings
794   install_initrd_chroot   install_initrd_chroot
795    
796   dialog_install_bootsector   dialog_install_bootsector
797   install_bootsector_chroot   install_bootsector_chroot
798    
799   install_umount_rootfs_flash   install_umount_rootfs
800   dialog_install_successful   dialog_install_successful
801  }  }
802    
803    # set some proper traps
804    trap "trap_exit" SIGINT SIGQUIT
805    
806  dialog_main  dialog_main
807    
808  exit 0  exit 0

Legend:
Removed from v.2335  
changed lines
  Added in v.2425